import matplotlib.artist as martist
from collections.abc import MutableSequence
from matplotlib import cbook as cbook, docstring as docstring
from matplotlib.cbook import index_of as index_of
from matplotlib.rcsetup import cycler as cycler, validate_axisbelow as validate_axisbelow
from typing import Any

class _axis_method_wrapper:
    attr_name: Any
    method_name: Any
    __doc__: Any
    def __init__(self, attr_name, method_name, *, doc_sub: Any | None = ...) -> None: ...
    def __set_name__(self, owner, name): ...

class _TransformedBoundsLocator:
    def __init__(self, bounds, transform) -> None: ...
    def __call__(self, ax, renderer): ...

class _process_plot_var_args:
    axes: Any
    command: Any
    def __init__(self, axes, command: str = ...) -> None: ...
    prop_cycler: Any
    def set_prop_cycle(self, cycler) -> None: ...
    def __call__(self, *args, data: Any | None = ..., **kwargs) -> None: ...
    def get_next_color(self): ...

class _AxesBase(martist.Artist):
    name: str
    axes: Any
    spines: Any
    fmt_xdata: Any
    fmt_ydata: Any
    def __init__(self, fig, rect, facecolor: Any | None = ..., frameon: bool = ..., sharex: Any | None = ..., sharey: Any | None = ..., label: str = ..., xscale: Any | None = ..., yscale: Any | None = ..., box_aspect: Any | None = ..., **kwargs) -> None: ...
    def get_window_extent(self, *args, **kwargs): ...
    bbox: Any
    dataLim: Any
    transScale: Any
    def set_figure(self, fig) -> None: ...
    @property
    def viewLim(self): ...
    def get_xaxis_transform(self, which: str = ...): ...
    def get_xaxis_text1_transform(self, pad_points): ...
    def get_xaxis_text2_transform(self, pad_points): ...
    def get_yaxis_transform(self, which: str = ...): ...
    def get_yaxis_text1_transform(self, pad_points): ...
    def get_yaxis_text2_transform(self, pad_points): ...
    def get_position(self, original: bool = ...): ...
    def set_position(self, pos, which: str = ...) -> None: ...
    def reset_position(self) -> None: ...
    stale: bool
    def set_axes_locator(self, locator) -> None: ...
    def get_axes_locator(self): ...
    def sharex(self, other) -> None: ...
    def sharey(self, other) -> None: ...
    ignore_existing_data_limits: bool
    callbacks: Any
    child_axes: Any
    legend_: Any
    containers: Any
    title: Any
    patch: Any
    def cla(self) -> None: ...
    class ArtistList(MutableSequence):
        def __init__(self, axes, prop_name, add_name, valid_types: Any | None = ..., invalid_types: Any | None = ...): ...
        def __len__(self): ...
        def __iter__(self): ...
        def __getitem__(self, key): ...
        def __add__(self, other): ...
        def __radd__(self, other): ...
        def insert(self, index, item) -> None: ...
        def __setitem__(self, key, item) -> None: ...
        def __delitem__(self, key) -> None: ...
    @property
    def artists(self): ...
    @property
    def collections(self): ...
    @property
    def images(self): ...
    @property
    def lines(self): ...
    @property
    def patches(self): ...
    @property
    def tables(self): ...
    @property
    def texts(self): ...
    def clear(self) -> None: ...
    def get_facecolor(self): ...
    def set_facecolor(self, color): ...
    def set_prop_cycle(self, *args, **kwargs) -> None: ...
    def get_aspect(self): ...
    def set_aspect(self, aspect, adjustable: Any | None = ..., anchor: Any | None = ..., share: bool = ...) -> None: ...
    def get_adjustable(self): ...
    def set_adjustable(self, adjustable, share: bool = ...) -> None: ...
    def get_box_aspect(self): ...
    def set_box_aspect(self, aspect: Any | None = ...) -> None: ...
    def get_anchor(self): ...
    def set_anchor(self, anchor, share: bool = ...) -> None: ...
    def get_data_ratio(self): ...
    def apply_aspect(self, position: Any | None = ...) -> None: ...
    def axis(self, *args, emit: bool = ..., **kwargs): ...
    def get_legend(self): ...
    def get_images(self): ...
    def get_lines(self): ...
    def get_xaxis(self): ...
    def get_yaxis(self): ...
    get_xgridlines: Any
    get_xticklines: Any
    get_ygridlines: Any
    get_yticklines: Any
    def has_data(self): ...
    def add_artist(self, a): ...
    def add_child_axes(self, ax): ...
    def add_collection(self, collection, autolim: bool = ...): ...
    def add_image(self, image): ...
    def add_line(self, line): ...
    def add_patch(self, p): ...
    def add_table(self, tab): ...
    def add_container(self, container): ...
    def relim(self, visible_only: bool = ...) -> None: ...
    def update_datalim(self, xys, updatex: bool = ..., updatey: bool = ...) -> None: ...
    def in_axes(self, mouseevent): ...
    def get_autoscale_on(self): ...
    def get_autoscalex_on(self): ...
    def get_autoscaley_on(self): ...
    def set_autoscale_on(self, b) -> None: ...
    def set_autoscalex_on(self, b) -> None: ...
    def set_autoscaley_on(self, b) -> None: ...
    @property
    def use_sticky_edges(self): ...
    @use_sticky_edges.setter
    def use_sticky_edges(self, b) -> None: ...
    def set_xmargin(self, m) -> None: ...
    def set_ymargin(self, m) -> None: ...
    def margins(self, *margins, x: Any | None = ..., y: Any | None = ..., tight: bool = ...): ...
    def set_rasterization_zorder(self, z) -> None: ...
    def get_rasterization_zorder(self): ...
    def autoscale(self, enable: bool = ..., axis: str = ..., tight: Any | None = ...) -> None: ...
    def autoscale_view(self, tight: Any | None = ..., scalex: bool = ..., scaley: bool = ...) -> None: ...
    def draw(self, renderer) -> None: ...
    def draw_artist(self, a) -> None: ...
    def redraw_in_frame(self) -> None: ...
    def get_renderer_cache(self): ...
    def get_frame_on(self): ...
    def set_frame_on(self, b) -> None: ...
    def get_axisbelow(self): ...
    def set_axisbelow(self, b) -> None: ...
    def grid(self, visible: Any | None = ..., which: str = ..., axis: str = ..., **kwargs) -> None: ...
    def ticklabel_format(self, *, axis: str = ..., style: str = ..., scilimits: Any | None = ..., useOffset: Any | None = ..., useLocale: Any | None = ..., useMathText: Any | None = ...) -> None: ...
    def locator_params(self, axis: str = ..., tight: Any | None = ..., **kwargs) -> None: ...
    def tick_params(self, axis: str = ..., **kwargs) -> None: ...
    axison: bool
    def set_axis_off(self) -> None: ...
    def set_axis_on(self) -> None: ...
    def get_xlabel(self): ...
    def set_xlabel(self, xlabel, fontdict: Any | None = ..., labelpad: Any | None = ..., *, loc: Any | None = ..., **kwargs): ...
    def invert_xaxis(self) -> None: ...
    xaxis_inverted: Any
    def get_xbound(self): ...
    def set_xbound(self, lower: Any | None = ..., upper: Any | None = ...) -> None: ...
    def get_xlim(self): ...
    def set_xlim(self, left: Any | None = ..., right: Any | None = ..., emit: bool = ..., auto: bool = ..., *, xmin: Any | None = ..., xmax: Any | None = ...): ...
    get_xscale: Any
    def set_xscale(self, value, **kwargs) -> None: ...
    get_xticks: Any
    set_xticks: Any
    get_xmajorticklabels: Any
    get_xminorticklabels: Any
    get_xticklabels: Any
    set_xticklabels: Any
    def get_ylabel(self): ...
    def set_ylabel(self, ylabel, fontdict: Any | None = ..., labelpad: Any | None = ..., *, loc: Any | None = ..., **kwargs): ...
    def invert_yaxis(self) -> None: ...
    yaxis_inverted: Any
    def get_ybound(self): ...
    def set_ybound(self, lower: Any | None = ..., upper: Any | None = ...) -> None: ...
    def get_ylim(self): ...
    def set_ylim(self, bottom: Any | None = ..., top: Any | None = ..., emit: bool = ..., auto: bool = ..., *, ymin: Any | None = ..., ymax: Any | None = ...): ...
    get_yscale: Any
    def set_yscale(self, value, **kwargs) -> None: ...
    get_yticks: Any
    set_yticks: Any
    get_ymajorticklabels: Any
    get_yminorticklabels: Any
    get_yticklabels: Any
    set_yticklabels: Any
    xaxis_date: Any
    yaxis_date: Any
    def format_xdata(self, x): ...
    def format_ydata(self, y): ...
    def format_coord(self, x, y): ...
    def minorticks_on(self) -> None: ...
    def minorticks_off(self) -> None: ...
    def can_zoom(self): ...
    def can_pan(self): ...
    def get_navigate(self): ...
    def set_navigate(self, b) -> None: ...
    def get_navigate_mode(self): ...
    def set_navigate_mode(self, b) -> None: ...
    def start_pan(self, x, y, button) -> None: ...
    def end_pan(self) -> None: ...
    def drag_pan(self, button, key, x, y) -> None: ...
    def get_children(self): ...
    def contains(self, mouseevent): ...
    def contains_point(self, point): ...
    def get_default_bbox_extra_artists(self): ...
    def get_tightbbox(self, renderer, call_axes_locator: bool = ..., bbox_extra_artists: Any | None = ..., *, for_layout_only: bool = ...): ...
    def twinx(self): ...
    def twiny(self): ...
    def get_shared_x_axes(self): ...
    def get_shared_y_axes(self): ...
