import matplotlib.spines as mspines
from matplotlib import cm as cm, collections as collections, colors as colors, contour as contour, docstring as docstring, ticker as ticker
from typing import Any

class __getattr__:
    colorbar_doc: Any
    colorbar_kw_doc: Any
    make_axes_kw_doc: Any

class _ColorbarSpine(mspines.Spine):
    def __init__(self, axes) -> None: ...
    def get_window_extent(self, renderer: Any | None = ...): ...
    stale: bool
    def set_xy(self, xy) -> None: ...
    def draw(self, renderer): ...

class _ColorbarAxesLocator:
    def __init__(self, cbar) -> None: ...
    def __call__(self, ax, renderer): ...
    def get_subplotspec(self): ...

class Colorbar:
    n_rasterize: int
    mappable: Any
    ax: Any
    alpha: Any
    cmap: Any
    norm: Any
    values: Any
    boundaries: Any
    extend: Any
    spacing: Any
    orientation: Any
    drawedges: Any
    filled: Any
    extendfrac: Any
    extendrect: Any
    solids: Any
    solids_patches: Any
    lines: Any
    outline: Any
    dividers: Any
    locator: Any
    minorlocator: Any
    formatter: Any
    ticklocation: Any
    def __init__(self, ax, mappable: Any | None = ..., *, cmap: Any | None = ..., norm: Any | None = ..., alpha: Any | None = ..., values: Any | None = ..., boundaries: Any | None = ..., orientation: str = ..., ticklocation: str = ..., extend: Any | None = ..., spacing: str = ..., ticks: Any | None = ..., format: Any | None = ..., drawedges: bool = ..., filled: bool = ..., extendfrac: Any | None = ..., extendrect: bool = ..., label: str = ...) -> None: ...
    patch: Any
    stale: bool
    def update_normal(self, mappable) -> None: ...
    def draw_all(self) -> None: ...
    def add_lines(self, *args, **kwargs): ...
    def update_ticks(self) -> None: ...
    def set_ticks(self, ticks, update_ticks: bool = ..., labels: Any | None = ..., *, minor: bool = ..., **kwargs) -> None: ...
    def get_ticks(self, minor: bool = ...): ...
    def set_ticklabels(self, ticklabels, update_ticks: bool = ..., *, minor: bool = ..., **kwargs) -> None: ...
    def minorticks_on(self) -> None: ...
    def minorticks_off(self) -> None: ...
    def set_label(self, label, *, loc: Any | None = ..., **kwargs) -> None: ...
    def set_alpha(self, alpha) -> None: ...
    def remove(self) -> None: ...
    def drag_pan(self, button, key, x, y) -> None: ...
ColorbarBase = Colorbar

def make_axes(parents, location: Any | None = ..., orientation: Any | None = ..., fraction: float = ..., shrink: float = ..., aspect: int = ..., **kw): ...
def make_axes_gridspec(parent, *, location: Any | None = ..., orientation: Any | None = ..., fraction: float = ..., shrink: float = ..., aspect: int = ..., **kw): ...

class ColorbarPatch(Colorbar): ...

def colorbar_factory(cax, mappable, **kwargs): ...
