from ..palettes import color_palette as color_palette
from ..relational import lineplot as lineplot, relplot as relplot, scatterplot as scatterplot

def long_semantics(request): ...

class Helpers:
    def scatter_rgbs(self, collections): ...
    def paths_equal(self, *args): ...

class TestRelationalPlotter(Helpers):
    def test_wide_df_variables(self, wide_df) -> None: ...
    def test_wide_df_with_nonnumeric_variables(self, long_df) -> None: ...
    def test_wide_array_variables(self, wide_array) -> None: ...
    def test_flat_array_variables(self, flat_array) -> None: ...
    def test_flat_list_variables(self, flat_list) -> None: ...
    def test_flat_series_variables(self, flat_series) -> None: ...
    def test_wide_list_of_series_variables(self, wide_list_of_series) -> None: ...
    def test_wide_list_of_arrays_variables(self, wide_list_of_arrays) -> None: ...
    def test_wide_list_of_list_variables(self, wide_list_of_lists) -> None: ...
    def test_wide_dict_of_series_variables(self, wide_dict_of_series) -> None: ...
    def test_wide_dict_of_arrays_variables(self, wide_dict_of_arrays) -> None: ...
    def test_wide_dict_of_lists_variables(self, wide_dict_of_lists) -> None: ...
    def test_long_df(self, long_df, long_semantics) -> None: ...
    def test_long_df_with_index(self, long_df, long_semantics) -> None: ...
    def test_long_df_with_multiindex(self, long_df, long_semantics) -> None: ...
    def test_long_dict(self, long_dict, long_semantics) -> None: ...
    def test_long_vectors(self, long_df, long_semantics, vector_type) -> None: ...
    def test_long_undefined_variables(self, long_df) -> None: ...
    def test_empty_data_input(self, arg) -> None: ...
    def test_units(self, repeated_df) -> None: ...
    def test_relplot_simple(self, long_df) -> None: ...
    def test_relplot_complex(self, long_df) -> None: ...
    def test_relplot_vectors(self, long_df, vector_type) -> None: ...
    def test_relplot_wide(self, wide_df) -> None: ...
    def test_relplot_hues(self, long_df) -> None: ...
    def test_relplot_sizes(self, long_df) -> None: ...
    def test_relplot_styles(self, long_df) -> None: ...
    def test_relplot_stringy_numerics(self, long_df) -> None: ...
    def test_relplot_legend(self, long_df) -> None: ...
    def test_relplot_data(self, long_df) -> None: ...
    def test_facet_variable_collision(self, long_df) -> None: ...
    def test_ax_kwarg_removal(self, long_df) -> None: ...

class TestLinePlotter(Helpers):
    def test_aggregate(self, long_df): ...
    def test_legend_data(self, long_df) -> None: ...
    def test_plot(self, long_df, repeated_df) -> None: ...
    def test_axis_labels(self, long_df) -> None: ...
    def test_matplotlib_kwargs(self, long_df) -> None: ...
    def test_lineplot_axes(self, wide_df) -> None: ...
    def test_lineplot_vs_relplot(self, long_df, long_semantics) -> None: ...
    def test_lineplot_smoke(self, wide_df, wide_array, wide_list_of_series, wide_list_of_arrays, wide_list_of_lists, flat_array, flat_series, flat_list, long_df, missing_df, object_df) -> None: ...

class TestScatterPlotter(Helpers):
    def test_legend_data(self, long_df) -> None: ...
    def test_plot(self, long_df, repeated_df) -> None: ...
    def test_axis_labels(self, long_df) -> None: ...
    def test_scatterplot_axes(self, wide_df) -> None: ...
    def test_literal_attribute_vectors(self) -> None: ...
    def test_linewidths(self, long_df) -> None: ...
    def test_size_norm_extrapolation(self) -> None: ...
    def test_datetime_scale(self, long_df) -> None: ...
    def test_unfilled_marker_edgecolor_warning(self, long_df) -> None: ...
    def test_scatterplot_vs_relplot(self, long_df, long_semantics) -> None: ...
    def test_scatterplot_smoke(self, wide_df, wide_array, flat_series, flat_array, flat_list, wide_list_of_series, wide_list_of_arrays, wide_list_of_lists, long_df, missing_df, object_df) -> None: ...
