from sklearn import datasets as datasets, svm as svm
from sklearn.datasets import make_multilabel_classification as make_multilabel_classification
from sklearn.exceptions import UndefinedMetricWarning as UndefinedMetricWarning
from sklearn.metrics import accuracy_score as accuracy_score, average_precision_score as average_precision_score, balanced_accuracy_score as balanced_accuracy_score, brier_score_loss as brier_score_loss, classification_report as classification_report, cohen_kappa_score as cohen_kappa_score, confusion_matrix as confusion_matrix, f1_score as f1_score, fbeta_score as fbeta_score, hamming_loss as hamming_loss, hinge_loss as hinge_loss, jaccard_score as jaccard_score, log_loss as log_loss, matthews_corrcoef as matthews_corrcoef, multilabel_confusion_matrix as multilabel_confusion_matrix, precision_recall_fscore_support as precision_recall_fscore_support, precision_score as precision_score, recall_score as recall_score, zero_one_loss as zero_one_loss
from sklearn.preprocessing import LabelBinarizer as LabelBinarizer, label_binarize as label_binarize
from sklearn.utils._mocking import MockDataFrame as MockDataFrame
from sklearn.utils._testing import assert_allclose as assert_allclose, assert_almost_equal as assert_almost_equal, assert_array_almost_equal as assert_array_almost_equal, assert_array_equal as assert_array_equal, assert_no_warnings as assert_no_warnings, ignore_warnings as ignore_warnings
from sklearn.utils.validation import check_random_state as check_random_state
from typing import Any

def make_prediction(dataset: Any | None = ..., binary: bool = ...): ...
def test_classification_report_dictionary_output() -> None: ...
def test_classification_report_output_dict_empty_input() -> None: ...
def test_classification_report_zero_division_warning(zero_division) -> None: ...
def test_multilabel_accuracy_score_subset_accuracy() -> None: ...
def test_precision_recall_f1_score_binary() -> None: ...
def test_precision_recall_f_binary_single_class() -> None: ...
def test_precision_recall_f_extra_labels() -> None: ...
def test_precision_recall_f_ignored_labels() -> None: ...
def test_average_precision_score_score_non_binary_class() -> None: ...
def test_average_precision_score_duplicate_values() -> None: ...
def test_average_precision_score_tied_values() -> None: ...
def test_precision_recall_fscore_support_errors() -> None: ...
def test_precision_recall_f_unused_pos_label() -> None: ...
def test_confusion_matrix_binary() -> None: ...
def test_multilabel_confusion_matrix_binary() -> None: ...
def test_multilabel_confusion_matrix_multiclass() -> None: ...
def test_multilabel_confusion_matrix_multilabel() -> None: ...
def test_multilabel_confusion_matrix_errors() -> None: ...
def test_confusion_matrix_normalize(normalize, cm_dtype, expected_results) -> None: ...
def test_confusion_matrix_normalize_wrong_option() -> None: ...
def test_confusion_matrix_normalize_single_class() -> None: ...
def test_cohen_kappa() -> None: ...
def test_matthews_corrcoef_nan() -> None: ...
def test_matthews_corrcoef_against_numpy_corrcoef() -> None: ...
def test_matthews_corrcoef_against_jurman() -> None: ...
def test_matthews_corrcoef() -> None: ...
def test_matthews_corrcoef_multiclass() -> None: ...
def test_matthews_corrcoef_overflow(n_points): ...
def test_precision_recall_f1_score_multiclass() -> None: ...
def test_precision_refcall_f1_score_multilabel_unordered_labels(average) -> None: ...
def test_precision_recall_f1_score_binary_averaged() -> None: ...
def test_zero_precision_recall() -> None: ...
def test_confusion_matrix_multiclass_subset_labels() -> None: ...
def test_confusion_matrix_error(labels, err_msg) -> None: ...
def test_confusion_matrix_on_zero_length_input(labels) -> None: ...
def test_confusion_matrix_dtype() -> None: ...
def test_classification_report_multiclass() -> None: ...
def test_classification_report_multiclass_balanced() -> None: ...
def test_classification_report_multiclass_with_label_detection() -> None: ...
def test_classification_report_multiclass_with_digits() -> None: ...
def test_classification_report_multiclass_with_string_label() -> None: ...
def test_classification_report_multiclass_with_unicode_label() -> None: ...
def test_classification_report_multiclass_with_long_string_label() -> None: ...
def test_classification_report_labels_target_names_unequal_length() -> None: ...
def test_classification_report_no_labels_target_names_unequal_length() -> None: ...
def test_multilabel_classification_report() -> None: ...
def test_multilabel_zero_one_loss_subset() -> None: ...
def test_multilabel_hamming_loss() -> None: ...
def test_jaccard_score_validation() -> None: ...
def test_multilabel_jaccard_score(recwarn) -> None: ...
def test_multiclass_jaccard_score(recwarn) -> None: ...
def test_average_binary_jaccard_score(recwarn) -> None: ...
def test_jaccard_score_zero_division_warning() -> None: ...
def test_jaccard_score_zero_division_set_value(zero_division, expected_score) -> None: ...
def test_precision_recall_f1_score_multilabel_1() -> None: ...
def test_precision_recall_f1_score_multilabel_2() -> None: ...
def test_precision_recall_f1_score_with_an_empty_prediction(zero_division) -> None: ...
def test_precision_recall_f1_no_labels(beta, average, zero_division) -> None: ...
def test_precision_recall_f1_no_labels_check_warnings(average) -> None: ...
def test_precision_recall_f1_no_labels_average_none(zero_division) -> None: ...
def test_precision_recall_f1_no_labels_average_none_warn() -> None: ...
def test_prf_warnings() -> None: ...
def test_prf_no_warnings_if_zero_division_set(zero_division) -> None: ...
def test_recall_warnings(zero_division) -> None: ...
def test_precision_warnings(zero_division) -> None: ...
def test_fscore_warnings(zero_division) -> None: ...
def test_prf_average_binary_data_non_binary() -> None: ...
def test__check_targets() -> None: ...
def test__check_targets_multiclass_with_both_y_true_and_y_pred_binary() -> None: ...
def test_hinge_loss_binary() -> None: ...
def test_hinge_loss_multiclass() -> None: ...
def test_hinge_loss_multiclass_missing_labels_with_labels_none() -> None: ...
def test_hinge_loss_multiclass_no_consistent_pred_decision_shape() -> None: ...
def test_hinge_loss_multiclass_with_missing_labels() -> None: ...
def test_hinge_loss_multiclass_missing_labels_only_two_unq_in_y_true() -> None: ...
def test_hinge_loss_multiclass_invariance_lists() -> None: ...
def test_log_loss() -> None: ...
def test_log_loss_pandas_input() -> None: ...
def test_brier_score_loss() -> None: ...
def test_balanced_accuracy_score_unseen() -> None: ...
def test_balanced_accuracy_score(y_true, y_pred) -> None: ...
