from sklearn import datasets as datasets
from sklearn.base import clone as clone
from sklearn.exceptions import NotFittedError as NotFittedError
from sklearn.model_selection import cross_val_predict as cross_val_predict
from sklearn.pipeline import Pipeline as Pipeline
from sklearn.preprocessing import Binarizer as Binarizer, KernelCenterer as KernelCenterer, MaxAbsScaler as MaxAbsScaler, MinMaxScaler as MinMaxScaler, Normalizer as Normalizer, PowerTransformer as PowerTransformer, QuantileTransformer as QuantileTransformer, RobustScaler as RobustScaler, StandardScaler as StandardScaler, add_dummy_feature as add_dummy_feature, maxabs_scale as maxabs_scale, minmax_scale as minmax_scale, normalize as normalize, power_transform as power_transform, quantile_transform as quantile_transform, robust_scale as robust_scale, scale as scale
from sklearn.preprocessing._data import BOUNDS_THRESHOLD as BOUNDS_THRESHOLD
from sklearn.svm import SVR as SVR
from sklearn.utils import gen_batches as gen_batches, shuffle as shuffle
from sklearn.utils._testing import assert_allclose as assert_allclose, assert_allclose_dense_sparse as assert_allclose_dense_sparse, assert_almost_equal as assert_almost_equal, assert_array_almost_equal as assert_array_almost_equal, assert_array_equal as assert_array_equal, assert_array_less as assert_array_less, skip_if_32bit as skip_if_32bit
from sklearn.utils.sparsefuncs import mean_variance_axis as mean_variance_axis
from typing import Any

iris: Any
rng: Any
n_features: int
n_samples: int
offsets: Any
scales: Any
X_2d: Any
X_1row: Any
X_1col: Any
X_list_1row: Any
X_list_1col: Any

def toarray(a): ...
def assert_correct_incr(i, batch_start, batch_stop, n, chunk_size, n_samples_seen) -> None: ...
def test_raises_value_error_if_sample_weights_greater_than_1d() -> None: ...
def test_standard_scaler_sample_weight(Xw, X, sample_weight, array_constructor) -> None: ...
def test_standard_scaler_1d() -> None: ...
def test_standard_scaler_dtype(add_sample_weight, sparse_constructor) -> None: ...
def test_standard_scaler_constant_features(scaler, add_sample_weight, sparse_constructor, dtype, constant) -> None: ...
def test_standard_scaler_near_constant_features(n_samples, array_constructor, average, dtype) -> None: ...
def test_scale_1d() -> None: ...
def test_standard_scaler_numerical_stability() -> None: ...
def test_scaler_2d_arrays() -> None: ...
def test_scaler_float16_overflow() -> None: ...
def test_handle_zeros_in_scale() -> None: ...
def test_minmax_scaler_partial_fit() -> None: ...
def test_standard_scaler_partial_fit() -> None: ...
def test_standard_scaler_partial_fit_numerical_stability() -> None: ...
def test_partial_fit_sparse_input(sample_weight) -> None: ...
def test_standard_scaler_trasform_with_partial_fit(sample_weight) -> None: ...
def test_standard_check_array_of_inverse_transform() -> None: ...
def test_min_max_scaler_iris() -> None: ...
def test_min_max_scaler_zero_variance_features() -> None: ...
def test_minmax_scale_axis1() -> None: ...
def test_min_max_scaler_1d() -> None: ...
def test_scaler_without_centering(sample_weight) -> None: ...
def test_scaler_n_samples_seen_with_nan(with_mean, with_std, array_constructor) -> None: ...
def test_scaler_return_identity() -> None: ...
def test_scaler_int() -> None: ...
def test_scaler_without_copy() -> None: ...
def test_scale_sparse_with_mean_raise_exception() -> None: ...
def test_scale_input_finiteness_validation() -> None: ...
def test_robust_scaler_error_sparse() -> None: ...
def test_robust_scaler_attributes(X, with_centering, with_scaling) -> None: ...
def test_robust_scaler_col_zero_sparse() -> None: ...
def test_robust_scaler_2d_arrays() -> None: ...
def test_robust_scaler_equivalence_dense_sparse(density, strictly_signed) -> None: ...
def test_robust_scaler_transform_one_row_csr() -> None: ...
def test_robust_scaler_iris() -> None: ...
def test_robust_scaler_iris_quantiles() -> None: ...
def test_quantile_transform_iris() -> None: ...
def test_quantile_transform_check_error() -> None: ...
def test_quantile_transform_sparse_ignore_zeros() -> None: ...
def test_quantile_transform_dense_toy() -> None: ...
def test_quantile_transform_subsampling() -> None: ...
def test_quantile_transform_sparse_toy() -> None: ...
def test_quantile_transform_axis1() -> None: ...
def test_quantile_transform_bounds() -> None: ...
def test_quantile_transform_and_inverse() -> None: ...
def test_quantile_transform_nan() -> None: ...
def test_quantile_transformer_sorted_quantiles(array_type) -> None: ...
def test_robust_scaler_invalid_range() -> None: ...
def test_scale_function_without_centering() -> None: ...
def test_robust_scale_axis1() -> None: ...
def test_robust_scale_1d_array() -> None: ...
def test_robust_scaler_zero_variance_features() -> None: ...
def test_robust_scaler_unit_variance() -> None: ...
def test_maxabs_scaler_zero_variance_features() -> None: ...
def test_maxabs_scaler_large_negative_value() -> None: ...
def test_maxabs_scaler_transform_one_row_csr() -> None: ...
def test_maxabs_scaler_1d() -> None: ...
def test_maxabs_scaler_partial_fit() -> None: ...
def test_normalizer_l1() -> None: ...
def test_normalizer_l2() -> None: ...
def test_normalizer_max() -> None: ...
def test_normalizer_max_sign() -> None: ...
def test_normalize() -> None: ...
def test_binarizer() -> None: ...
def test_center_kernel() -> None: ...
def test_kernelcenterer_non_linear_kernel(): ...
def test_cv_pipeline_precomputed() -> None: ...
def test_pairwise_deprecated() -> None: ...
def test_fit_transform() -> None: ...
def test_add_dummy_feature() -> None: ...
def test_add_dummy_feature_coo() -> None: ...
def test_add_dummy_feature_csc() -> None: ...
def test_add_dummy_feature_csr() -> None: ...
def test_fit_cold_start() -> None: ...
def test_quantile_transform_valid_axis() -> None: ...
def test_power_transformer_notfitted(method) -> None: ...
def test_power_transformer_inverse(method, standardize, X) -> None: ...
def test_power_transformer_1d() -> None: ...
def test_power_transformer_2d() -> None: ...
def test_power_transformer_boxcox_strictly_positive_exception() -> None: ...
def test_power_transformer_yeojohnson_any_input(X) -> None: ...
def test_power_transformer_shape_exception(method) -> None: ...
def test_power_transformer_method_exception() -> None: ...
def test_power_transformer_lambda_zero() -> None: ...
def test_power_transformer_lambda_one() -> None: ...
def test_optimization_power_transformer(method, lmbda) -> None: ...
def test_yeo_johnson_darwin_example() -> None: ...
def test_power_transformer_nans(method) -> None: ...
def test_power_transformer_fit_transform(method, standardize) -> None: ...
def test_power_transformer_copy_True(method, standardize) -> None: ...
def test_power_transformer_copy_False(method, standardize) -> None: ...
def test_standard_scaler_sparse_partial_fit_finite_variance(X_2) -> None: ...
def test_minmax_scaler_clip(feature_range) -> None: ...
def test_standard_scaler_raise_error_for_1d_input() -> None: ...
def test_one_to_one_features(Transformer) -> None: ...
def test_one_to_one_features_pandas(Transformer) -> None: ...
