from tensorflow.python.profiler import tfprof_logger as tfprof_logger
from tensorflow.python.util.tf_export import tf_export as tf_export
from typing import Any

class ProfileOptionBuilder:
    def __init__(self, options: Any | None = ...) -> None: ...
    @staticmethod
    def trainable_variables_parameter(): ...
    @staticmethod
    def float_operation(): ...
    @staticmethod
    def time_and_memory(min_micros: int = ..., min_bytes: int = ..., min_accelerator_micros: int = ..., min_cpu_micros: int = ..., min_peak_bytes: int = ..., min_residual_bytes: int = ..., min_output_bytes: int = ...): ...
    def build(self): ...
    def with_max_depth(self, max_depth): ...
    def with_min_memory(self, min_bytes: int = ..., min_peak_bytes: int = ..., min_residual_bytes: int = ..., min_output_bytes: int = ...): ...
    def with_min_execution_time(self, min_micros: int = ..., min_accelerator_micros: int = ..., min_cpu_micros: int = ...): ...
    def with_min_parameters(self, min_params): ...
    def with_min_occurrence(self, min_occurrence): ...
    def with_min_float_operations(self, min_float_ops): ...
    def with_accounted_types(self, account_type_regexes): ...
    def with_node_names(self, start_name_regexes: Any | None = ..., show_name_regexes: Any | None = ..., hide_name_regexes: Any | None = ..., trim_name_regexes: Any | None = ...): ...
    def account_displayed_op_only(self, is_true): ...
    def with_empty_output(self): ...
    def with_stdout_output(self): ...
    def with_file_output(self, outfile): ...
    def with_timeline_output(self, timeline_file): ...
    def with_pprof_output(self, pprof_file): ...
    def order_by(self, attribute): ...
    def select(self, attributes): ...
    def with_step(self, step): ...
